// /***************
//  * Gnome-Panel *
//  ***************/

%gnome_panel_toplevel {
  background-color: $panel_bg;

  @if $maj_ver == 3 {
    * { outline-width: 0; } // unset outlines
  }
  @else {
    *:focus(visible) { outline-width: 0; } // unset outlines
  }
}

%gnome_panel_applet {
  // do not set transparent background in this template
  // mate-panel >= 1.18.6 will be broken
  color: if($variant == mixed, $inv_fg, $fg);
  box-shadow: none;
}

%gnome_panel_menubar {
  border: unset;
  color: if($variant == mixed, $inv_fg, $fg);
  background-color: transparent;
  font-weight: 700;
}

%gnome_panel_menuitem {
  padding: 0 rem($menu_padding, $sw: 1.0);
  @include radius(0, none);
  color: if($variant == mixed, $inv_fg, $fg);
  background-color: transparent;
  &:hover {
    @if $variant != light {
      @include button(flat-lined-checked, $tc: $sel_fg);
    }
    @else {
      @include button(flat-lined-checked, $tc: black);
    }
  }
}

panel-toplevel.background { @extend %gnome_panel_toplevel; }

panel-applet,
panel-plug,
panel-toplevel > grid.horizontal > widget > widget {
  @extend %gnome_panel_applet;
  background-color: transparent;
}

.gnome-panel-menu-bar,
gp-applet > menubar,
#clock-applet-button {
  @extend %gnome_panel_menubar;

  .background & { border: unset; }
}

@if $maj_ver == 3 {
  .gnome-panel-menu-bar > menuitem,
  gp-applet menubar > menuitem {
    @extend %gnome_panel_menuitem;
    @extend %gnome_panel_menuitem_misc;
  }
}
@else {
  .gnome-panel-menu-bar > box > menuitem,
  gp-applet menubar > box > menuitem {
    @extend %gnome_panel_menuitem;
    @extend %gnome_panel_menuitem_misc;
  }
}

%gnome_panel_menuitem_misc {
  .vertical & { padding: rem($menu_padding, $sw: 1.0) 0; }

  @each $_layout, $_line in (top, 0 2px),
                            (left, 2px 0),
                            (right, -2px 0) {
    .#{$_layout} & {
      &:hover { box-shadow: inset #{$_line} $sel_bg; }
    }
  }
}

#tasklist-button,
#clock-applet-button,
#showdesktop-button {
  min-width: $icon_size;
  min-height: $icon_size;
  padding: 0 rem($menu_padding, $sw: 1.0);
  @include radius(0, none);
  @include transition(reset);
  @if $variant != light {
    @include button(flat-normal, $tc: $inv_fg);
    &:hover {
      @include button(flat-lined-hover, $tc: $sel_fg);
    }
    &:disabled { @include button(flat-disabled, $tc: $inv_fg); }
    &:checked {
      &, &:hover {
        @include button(flat-lined-checked, $tc: $sel_fg);
        background-color: track($sel_fg, $a_trk_1);
      }
    }

    &, &.flat {
      &:active { animation: none; }
    }
  }
  @else {
    @include button(flat-normal, $tc: $fg);
    &:hover {
      @include button(flat-lined-hover, $tc: black);
    }
    &:disabled { @include button(flat-disabled, $tc: $fg); }
    &:checked {
      &, &:hover {
        @include button(flat-lined-checked, $tc: black);
        background-color: track(black, $a_trk_1);
      }
    }

    &, &.flat {
      &:active { animation: none; }
    }
  }

  .vertical & { padding: rem($menu_padding, $sw: 1.0) 0; }

  @each $_layout, $_line in (top, 0 2px),
                            (left, 2px 0),
                            (right, -2px 0) {
    .#{$_layout} & {
      &:hover { box-shadow: inset #{$_line} $trk_out_fg; }
      &:checked,
      &:hover:checked { box-shadow: inset #{$_line} $sel_bg; }
    }
  }

  label { margin-bottom: 0; } // unset baseline
}

#tasklist-button {
  &,
  label { font-weight: 400; }
}

wnck-pager {
  @if $variant != light {
    background-color: transparent;
    color: mix($inv_fg, $panel_bg, percentage($a_fg_3rd)); // use opaque
    box-shadow:
      inset 0 0 0 1px mix($inv_fg, $panel_bg, percentage($a_fg_bdp));
    &:hover {
      background-color: $trk_bg;
      color: $inv_fg;
      box-shadow: inset 0 0 0 1px $trk_out_fg;
    }
    &:selected {
      background-color: track($sel_bg, $a_trk_out);
      color: $inv_fg;
      box-shadow: inset 0 0 0 1px $sel_bg;
    }
  }
  @else {
    background-color: transparent;
    color: mix($fg, $panel_bg, percentage($a_fg_3rd)); // use opaque
    box-shadow:
      inset 0 0 0 1px mix($fg, $panel_bg, percentage($a_fg_bdp));
    &:hover {
      background-color: $trk_bg;
      color: $fg;
      box-shadow: inset 0 0 0 1px $trk_out_fg;
    }
    &:selected {
      background-color: track($sel_bg, $a_trk_out);
      color: $fg;
      box-shadow: inset 0 0 0 1px $sel_bg;
    }
  }
}

na-tray-applet { -NaTrayApplet-icon-padding: 2px; }

gp-arrow-button {
  min-width: rem($widget_size / 2);
  min-height: 0;
  margin: 0 rem($menu_padding);
  border: 1px solid transparent;
  background-image: none;
  color: if($variant == mixed, $inv_fg, $fg);
  &:hover,
  &:active { color: if($variant != light, $sel_fg, black); }
}

sn-button { padding: 0 rem($menu_padding, $sw: 1.0); }

gp-applet > separator {
  &.vertical {
    min-width: 2px;
    margin: 3px;
  }

  background-color: $panel_div_fg;
}

// /****************
//  * Gnome Tweaks *
//  ****************/

headerbar.titlebar.tweak-titlebar {
  &-left,
  &-right { // unset baseline correction
    > label.title { margin-bottom: 0; }

    // for hdyleaflet
    + separator.vertical { background-color: $div_sld_dark_fg; }
  }
}

// sidebar
.tweak-categories {
  @extend %sidebar_template;
  background-image: image($bg);
  color: $sec_fg;

  separator.horizontal {
    min-height: 0;
    border-color: transparent;
    background-color: transparent;
  }
}

.tweak-category {
  border: none;
  color: $sec_fg;
  background-color: transparent;
  font-weight: 500;
  &:hover { color: $fg; }

  &.activatable { // specificity bump
    &:selected { @extend %selected_sidebar_row; }
  }
}

// basic row node container in right-pane
row.tweak {
  outline-width: 0; // hide outlines
  &:dir(ltr) { margin-left: rem($ref_size, $sw: 1.0); }
  &:dir(rtl) { margin-right: rem($ref_size, $sw: 1.0); }

  &, &.title {
    min-height: rem($widget_size);
    &:hover,
    &:active { // unset hover/active effects
      background-image: none;
      background-color: transparent;
      animation: none;
    }
  }

  &.title { color: $ter_fg; }

  &.title,
  &#AutostartTitle {
    font-weight: 700;
    // unset indentation
    &:dir(ltr) { margin-left: 0; }
    &:dir(rtl) { margin-right: 0; }
  }

  // child sub list elements
  &:not(.title) > list {
    border: 1px solid $div_fg;

    > row.activatable {
      background-color: $base;
      color: $sec_fg;
      &:hover {
        background-color: $trk_bg;
        color: $fg;
      }
      &:active { color: $fg; }

      > box.horizontal {
        > label,
        > box.vertical > label:first-child { font-weight: 500; }
      }

      // draw horizontal lines
      &:not(:last-child) { border-bottom: 1px solid $div_fg; }
    }
  }
}

// container and tweaks in a group
list.tweak-group-startup { background-color: $bg; }

%startup_list_row {
  padding: rem($entry_lr_space);
  background-image: image($bg);
  background-repeat: repeat-x;
  background-size: auto;
  transition-duration: 0s; // child 'grid' already has
  outline-width: 0; // hide outlines
  &:hover {
    > grid {
      background-image: image(track($sec_fg, $a_trk_1));
      transition: background-image $tr_d_std $tr_t_dec;
    }
  }
  &:active { @include transition(reset); } // disable ripples

  > grid { // actual container
    @include radius($r_2);
    padding: rem($entry_lr_space);
    transition: background-image $tr_d_std $tr_t_dec;

    > button { // 'remove' buttons
      @include button(raised-normal, $c: $dest_bg, $tc: $sec_sel_fg);
      @include ink-reaction(normal, $fc: $sel_fg, $tr: ink-normal-dec);
      &:hover { @include button(raised-hover, $c: $dest_bg, $tc: $sel_fg); }
      &:active {
        @include button(raised-active, $c: $sel_bg, $tc: $sel_fg);
        @include ink-reaction(active-dec, $fc: $sel_fg, $tr: ink-active-dec);
      }
      &:checked {
        @include button(raised-checked);
        &:disabled {
          border-color: mix($dest_bg, $bg, percentage($a_trk_1));
          background-color: mix($dest_bg, $bg, percentage($a_trk_1));
          color: $dis_sel_fg;
        }
      }
      &:disabled { @include button(raised-disabled, $c: $base, $tc: $fg); }
    }
  }
}

@if $maj_ver == 3 {
  @if $mnr_ver < 23 {
    list.tweak-group-startup {
      > row.activatable { @extend %startup_list_row; }
    }
  }
  @else {
    list.tweak-group-startup {
      > row {
        @extend %startup_list_row;
        &:hover > grid { background-image: none; }
      }
    }
  }
}
@else {
  list.tweak-group-startup {
    > row {
      @extend %startup_list_row;
      &:hover > grid { background-image: none; }
    }
  }
}

dialog.background.csd > box.dialog-vbox.vertical {
  > searchbar + scrolledwindow > viewport.frame > list {
    // FIXME: who needed hard-coded 5px outer margins
    // causing weird pitch black band?
    border: 1px solid $div_sld_fg; // use opaque
    box-shadow: 0 0 0 5px $bg;
  }
}

// /*******************
//  * Gnome-Flashback *
//  *******************/

// use message-dialog style for popup osd windows
$gf_margin: 12px;

%gf_window {
  @if $variant == mixed { color: $inv_fg; }
  @else { color: $fg; }

  levelbar block:not(.empty) { background-color: $sccs_bg; }

  &.solid {
    @if $variant == mixed { color: $inv_fg; }
    @else { color: $fg; }

    levelbar block:not(.empty) { background-color: $sccs_bg; }
  }

  &:not(.solid) {
    background: none;

    > box {
      padding: $gf_margin;
      @if $variant == mixed { background-color: track($inv_dark_bg, $a_osd); }
      @else { background-color: track($dark_bg, $a_osd); }
    }
  }

  // for non-composited environments
  &.solid {
    border-radius: 0;
    border: 1px solid $div_fg;
    @if $variant == mixed { background-color: track($inv_dark_bg, $a_osd); }
    @else { background-color: track($dark_bg, $a_osd); }
  }
}

%gf_window_decoration_3 {
  &:not(.solid) > box {
    margin: 0 0 (16px - $gf_margin);
    @include radius($r_4, none);
    box-shadow: $z-depth-3;
  }
}

%gf_window_decoration_4 {
  &:not(.solid) > box {
    margin: (16px - $gf_margin) (24px - $gf_margin) (32px - $gf_margin);
    @include radius($r_8, none);
    box-shadow: $z-depth-4;
  }
}

// popup window widget
#gf-label-window,
#gf-bubble,
#gf-osd-window,
#gf-input-source-popup {
  @extend %gf_window;
  @extend %gf_window_decoration_4;
}

#gf-label-window {
  font-size: rem($ref_size * 3, $sw: 1.0);
  font-weight: 400;
}

#gf-bubble box.horizontal > button.flat { // OSD-style button
  @if $variant == mixed {
    @extend %inv-action-area-button;
  }
  @else {
    @extend %action-area-button;
  }
  min-width: $icon_size;
  min-height: $icon_size;
  padding: rem($menuitem_padding, $sw: 1.0);
  @include radius($r);
}

#notification-popup-window {
  button.text-button:not(.flat) { // 'clear' button
    @extend %action-area-button;
  }

  button.flat:not(.text-button) { // close button
    min-width: $icon_size;
    min-height: $icon_size;
    padding: rem($menuitem_padding, $sw: 1.0);
    @include radius($r);
  }
}

// input-source switcher labels
#gf-input-source {
  min-width: rem($ref_size * 9, $sw: 1.0);
  min-height: rem($ref_size * 9, $sw: 1.0);
  color: if($variant != light, $inv_fg, $fg);
  font-size: rem(40px, $sw: 1.0);
  font-weight: 400;
  &:selected {
    border-radius: 2px;
    background-color: $trk_bg;
    color: if($variant != light, $inv_acc_fg, $acc_fg);
  }
}

// popup for input-source candidates
#gf-candidate-popup {
  @extend %gf_window;
  @extend %gf_window_decoration_3;

  gf-candidate-box {
    @include radius($r_2, none);
    color: if($variant == mixed, $inv_sec_fg, $sec_fg);
    @include transition(reset);

    label {
      padding: rem($baseline * 2)
               rem($entry_lr_space)
               rem($baseline * 3);
      font-size: 110%;
    }

    &:hover {
      background-color: $trk_bg;
      color: if($variant == mixed, $inv_fg, $fg);
    }
    &:selected {
      background-color: $sggt_bg;
      color: $sel_fg;
    }
  }

  .linked > button { // page-up&down buttons
    &, &.flat {
      @if $variant == mixed {
        @extend %inv-action-area-button;
      }
      @else {
        @extend %action-area-button;
      }
      min-height: rem($widget_size);
      min-width: rem($widget_size);
    }
  }
}

@if $maj_ver == 3 {
  @if $mnr_ver > 23 {
    gf-screensaver-panel { @extend %gf_ss_panel; }

    gf-icon { @extend %gf_icon; }
  }
}
@else {
  gf-screensaver-panel { @extend %gf_ss_panel; }

  gf-icon { @extend %gf_icon; }
}

%gf_ss_panel {
  @extend %gnome_panel_toplevel;
  @extend %gnome_panel_applet;
  padding: 4px 10px; // NEEDS_REVIEW

  label,
  image { color: if($variant == mixed, $inv_fg, $fg); }
}

%gf_icon {
  margin: 2px;
  @extend %nautilus_desktop_items;
  &:hover,
  &:selected {
    image {
      @if $maj_ver == 3 { -gtk-icon-effect: highlight; }
      @else { -gtk-icon-filter: brightness(1.2); }
    }
  }

  &:selected {
    label {
      background-color: $sel_bg;
      color: $sel_fg;
    }
  }

  label {
    padding: $r_2;
    border-radius: $r_2;
  }
}

@if $maj_ver == 3 {
  @if $mnr_ver > 23 {
    gf-unlock-dialog { @extend %gf_unlock_dialog; }
  }
}
@else {
  gf-unlock-dialog { @extend %gf_unlock_dialog; }
}

%gf_unlock_dialog {
  border-radius: $r_8;
  box-shadow: $z-depth-4;
  background: transparent;

  &.background { background: transparent; }

  > frame {
    border-radius: $r_8;
    @if $variant == mixed { // alpha compositing doesn't work though
      background-color: track($inv_dark_bg, $a_osd);
      color: $inv_fg;
    }
    @else {
      background-color: track($dark_bg, $a_osd);
      color: $fg;
    }

    &, > border { border: none; }
  }

  notebook {
    button {
      @if $variant == mixed { @extend %inv_flat_button; }
      @else { @extend %flat_button; }
    }

    entry:not(.flat) {
      min-height: rem($widget_size);
      @include radius($r_4 $r_4 0 0, none);
      border: none;
      @if $variant == mixed {
        @include entry(flat-normal, $tc: $inv_fg);
        caret-color: $inv_fg;
        &:focus { @include entry(flat-focus, $tc: $inv_fg); }
        &:disabled { @include entry(flat-disabled, $tc: $inv_fg); }

        selection { @extend %selected_items; }
      }
      @else {
        @include entry(flat-normal, $tc: $fg);
        caret-color: $fg;
        &:focus { @include entry(flat-focus, $tc: $fg); }
        &:disabled { @include entry(flat-disabled, $tc: $fg); }
      }
    }
  }

  buttonbox:not(.linked) button { // specificity bump
    &:not(.suggested-action):not(.destructive-action) {
      @if $variant == mixed { @extend %inv-action-area-button; }
      @else { @extend %action-area-button; }
    }
  }
}

// /************
//  * Nautilus *
//  ************/

%nautilus_desktop_items {
  color: $sel_fg;
  text-shadow: $z-depth-1-label; // non-sense for me
  &:selected { text-shadow: none; }
}

.nautilus-desktop-window {
  &,
  notebook,
  notebook > stack { background: transparent; }
}

.nautilus-desktop.nautilus-canvas-item { @extend %nautilus_desktop_items; }

.background.nautilus-window:not(.nautilus-desktop-window) {
  &:not(nautilus-desktop-window) {
    // enforce base-color backgrounds
    background-color: $base;
  }
}

.nautilus { // hide outlines
  &-canvas-item {
    @include radius($r_2, none);
    &:active:not(:focus) {
      // FIXME: prevent unneeded icon dimming when unfocused
      background-color: $sel_bg;
      color: $sel_fg;
    }
    @if $maj_ver == 3 {
      outline-width: 0; // unset outlines
    }
    @else {
      &:focus(visible) { outline-width: 0; } // unset outlines
    }
  }

  &-list-view treeview.view {
    @if $maj_ver == 3 {
      outline-width: 0; // unset outlines
    }
    @else {
      &:focus(visible) { outline-width: 0; } // unset outlines
    }
  }
}

.nautilus-circular-button { @include radius($r); }

.nautilus-window {
  > grid.horizontal paned > separator {
    // do not use transparentize
    background-image: image($div_sld_fg);
    background-size: $separator_narrow;
    background-repeat: repeat-y;
    @include transition(reset);
  }

  > headerbar.titlebar { // radial-progress widget
    revealer > button.popup.toggle {
      > widget { color: if($variant == mixed, $inv_acc_fg, $acc_fg); }

      &:checked > widget { color: $sel_fg; }
    }
  }

  $child_gap: if($ref_weight < 1.0, 4px, 6px);
  $container_padding: $child_gap ($child_gap * 1.5);
  $label_margin: ($child_gap / 2) (-$child_gap * 1.5) 0;
  $label_padding: if($ref_weight < 1.0,
                  ($child_gap - 1px) $child_gap $child_gap,
                  ($child_gap - 3px) $child_gap ($child_gap - 2px));

  flowboxchild { // experimental 'new view' mode
    margin: unset; // unset spacing first
    padding: unset;
    color: $fg;
    @if $maj_ver == 3 {
      outline-width: 0; // unset outlines
    }
    @else {
      &:focus(visible) { outline-width: 0; } // unset outlines
    }

    * { @include transition(reset); } // unset child transitions

    box.icon {
      &-item-background {
        padding: $container_padding;
        border: 0 none transparent;

        label {
          margin: $label_margin;
          padding: $label_padding;
          @include radius($r_2, none);
          background-color: transparent;
        }
      }

      &-background { // use solid black backgrounds
        border: 0 none transparent;
        @include radius($r_2, none);
        background-color: black;
      }
    }

    &:selected {
      &, &:focus {
        background-color: transparent; // unset selection color
      }

      box.icon {
        &-item-background label {
          background-color: $sel_bg;
          color: $sel_fg;
        }

        // tone up image node
        &-background image,
        &-item-background image {
          @if $maj_ver == 3 { -gtk-icon-effect: highlight; }
          @else { -gtk-icon-filter: brightness(1.2); }
        }
      }
    }
  }
}

.disk-space-display {
  border: 0 none transparent;

  &.free {
    @include radius($r, none);
    background-color: mix($fg, $base, percentage($a_trk_1)); // legacy
    color: mix($fg, $base, percentage($a_trk_1)); // >= 3.29.90
  }

  &.used {
    @include radius($r, none);
    background-color: $acc_bg;
    color: $acc_bg;
  }

  &.unknown {
    background-color: mix($acc_bg, $base, percentage($a_fg_3rd));
    color: mix($acc_bg, $base, percentage($a_fg_3rd));
  }
}

// 'batch-rename' dialogs
.conflict-row {
  background-color: $warn_bg;
  color: $sec_fix_fg;
  &:hover,
  &:active {
    background-color: $warn;
    color: $fix_fg;
  }
  &:selected { @extend %selected_items; }
}

// hide unwanted frame in batch-rename dialog
dialog.background.csd > box.dialog-vbox > grid.horizontal {
  > scrolledwindow.frame {
    > viewport.frame { margin: -1px; }
  }
}

.nautilus {
  &-canvas-item {
    @include radius($r_2, none);

    &.dim-label {
      color: $ter_fg;
      &:selected {
        &, &:focus { color: mix($sel_fg, $sel_bg, percentage($a_fg_3rd)); }
      }
    }
  }

  &-list-dim-label {
    color: $ter_fg;
    &:selected {
      &, &:focus { color: mix($sel_fg, $sel_bg, percentage($a_fg_3rd)); }
    }
  }
}

.documents-entry-tag { @extend .entry-tag; }

// /*********
//  * Geary *
//  *********/

.geary-titlebar-right {
  > .linked.raised > button {
    // 'archive' button
    &:not(.image-button):not(.text-button):not(.suggested-action) {
      > widget > box {
        > label {
          padding-bottom: 0;
          &:dir(ltr) { padding-left: 0; }
          &:dir(rtl) { padding-right: 0; }
        }

        > image { // archive icon
          margin-top: rem($baseline, $sw: 1.0); // reset baseline
        }
      }
    }
  }
}

%folder_frame_border { border-width: 0 0 1px; }

%conversation_frame {
  > border { border: none; }

  treeview.view {
    background-color: $bg;
    font-weight: 400; // reset weight
    &:selected {
      background-color: track($sel_bg, $a_trk_2);
      color: $fg;
      &:hover { background-color: track($sel_bg, $a_trk_2); }
      &:dir(ltr) { box-shadow: inset 4px 0 $sel_bg; }
      &:dir(rtl) { box-shadow: inset -4px 0 $sel_bg; }
      &:focus {
        background-color: track($sel_bg, $a_trk_2);
        color: $fg;
        &:hover { background-color: track($sel_bg, $a_trk_2); }
        &:dir(ltr) { box-shadow: inset 4px 0 $sel_bg; }
        &:dir(rtl) { box-shadow: inset -4px 0 $sel_bg; }
      }
    }
    &:hover { background-color: $trk_bg; }
  }
}

%folder_frame {
  @extend %sidebar_template;

  treeview.view.sidebar {
    @extend %sidebar_treeview;

    &.cell { // = row height of placessidebar
      min-height: rem($small_widget);
    }
  }
}

@if $maj_ver == 3 {
  @if $mnr_ver < 23 {
    // left-pane styling (legacy)
    .sidebar.vertical > paned.sidebar-pane-separator {
      .conversation-frame { @extend %conversation_frame; }

      .folder-frame {
        > border { @extend %folder_frame_border; }

        > scrolledwindow { @extend %folder_frame; }
      }
    }
  }
}

// left-pane styling (current)
.sidebar.vertical > paned.geary-sidebar-pane-separator {
  .geary-conversation-frame { @extend %conversation_frame; }

  .geary-folder-frame {
    > border { @extend  %folder_frame_border; }

    > scrolledwindow { @extend %folder_frame; }
  }
}

window.background > box.vertical > paned.horizontal > frame {
  // right-paned scrolledwindow
  > box.vertical > paned.vertical > overlay {
    > scrolledwindow > scrollbar { // always use light-variant
      background-color: transparent;

      slider {
        background-color: track($fix_fg, $a_fg_3rd * $a_fg_3rd);
        &:hover { background-color: track($fix_fg, $a_fg_2nd * $a_fg_3rd); }
        &:active { background-color: $fix_fg; }
        &:disabled { opacity: $a_fg_bdp; }
      }

      &.overlay-indicator {
        &:not(.dragging):not(.hovering) slider {
          background-color: track($fix_fg, $a_fg_3rd * $a_fg_3rd);
        }
      }
    }

    @if $maj_ver == 3 {
      @if $mnr_ver < 23 {
        > label.bottom { // mimic floating-bar styling
          @extend %floating_bar;
          padding: $toolbar_padding;

          &.left { @extend %floating_bar_left; }

          &.right { @extend %floating_bar_right; }
        }
      }
    }
  }
}

// right-pane styling
stack#conversation_viewer {
  scrolledwindow.geary-conversation-scroller {
    // FIXME: overshoot effect sometimes can't finish its transition,
    // then it causes ramaining some part of indicators.
    overshoot {
      &.top,
      &.bottom,
      &.left,
      &.right { background: none; }
    }

    > viewport.frame { border: none; } // unset borders
  }

  list.background.conversation-listbox {
    background-color: $bg;

    > row.activatable {
      > box.geary_email {
        margin: -1px; // hide hard-coded parent borders
        border-top: 1px solid $bg;

        grid.geary-message-summary {
          border-bottom: 1px solid $div_fg;
        }
      }

      &:not(.geary-expanded) { // retracted headers
        grid.geary-headers.vertical {
          label { @extend %dim_label; } // tone down
        }
      }

      > widget.geary-composer-embed {
        headerbar { // in-line headerbars
          margin: -1px -1px 0; // FIXME: does not work
          border-top: 1px solid $bg;
        }
      }
    }
  }
}

// /************
//  * Epiphany *
//  ************/

// incognito-mode styling
@if $maj_ver == 3 {
  @if $mnr_ver < 23 {
    // most of widget styling are hard-coded by ephy's stylesheet,
    // but we should force using dark foregrounds at least...

    headerbar.titlebar.incognito-mode {
      entry {
        @if $variant != light {
          @include entry(normal, $c: $fix_base,
                                 $tc: $fix_fg);
          caret-color: $fix_fg;
          &:focus {
            @include entry(focus, $c: $fix_base,
                                  $tc: $fix_fg);
            caret-color: $fix_fg;
          }
          &:disabled {
            @include entry(disabled, $c: $fix_base,
                                     $tc: $fix_fg);
          }
        }
      }

      button:not(.destructive-action):not(.suggested-action) {
        // these classes are specificity bump to override titlebuttons
        &:not(.appmenu):not(.icon):not(:indeterminate) {
          @if $variant != light {
            @include button(normal, $c: $fix_base,
                                    $tc: $fix_fg);
            @include ink-reaction(
                       normal, $fc: $fix_fg, $tr: ink-normal-dec);
            &:hover {
              @include button(hover, $c: $fix_base,
                                     $tc: $fix_fg);
            }
            &:active {
              @include button(active, $c: $fix_base,
                                      $tc: $fix_fg);
              @include ink-reaction(
                         active-dec, $fc: $fix_fg, $tr: ink-active-dec);
            }
            &:disabled {
              @include button(disabled, $c: $fix_base,
                                        $tc: $fix_fg);
            }
            &:checked { @include button(checked, $tc: $sel_fg); }
            &:checked:disabled {
              @include button(checked-disabled, $c: $fix_base,
                                                $tc: $fix_fg);
            }
          }
        }
      }
    }
  }
}

headerbar.titlebar.incognito-mode {
  buttonbox.linked > widget {
    color: if($variant == mixed, $inv_sec_fg, $sec_fg);
  }
}

// reset inverted foreground color
notebook > stack > box.vertical > paned.vertical > overlay {
  > .floating-bar { color: $sec_fg; }
}

// overrides foregrounds for 3.24's ssd-mode
.background headerbar entry {
  &.starred,
  &.non-starred {
    color: if($variant == mixed, $inv_sec_fg, $sec_fg);
    caret-color: if($variant == mixed, $inv_sec_fg, $sec_fg);
    &:focus {
      color: if($variant == mixed, $inv_fg, $fg);
      caret-color: if($variant == mixed, $inv_fg, $fg);
    }
    &:disabled {
      color: if($variant == mixed, $dis_inv_sec_fg, $dis_sec_fg);
    }
  }

  // render yellow 'star' icon if bookmarked
  &.starred > image.right {
    color: track($ques_bg, $a_fg_2nd);
    &:hover,
    &:active,
    &:checked { color: $ques_bg; }
  }
}

// popover for downloaded lists
@if $maj_ver == 3 {
  popover.background:not(.emoji-picker) > box.vertical > scrolledwindow {
    // re-define background colors for GtkListBox
    > viewport.frame > list.background {
      background-color: $dark_bg;
    }
  }
}
@else {
  popover:not(.emoji-picker) > box.vertical > scrolledwindow {
    // re-define background colors for GtkListBox
    > viewport.frame > list.background {
      background-color: $dark_bg;
    }
  }
}

// popover for bookmarks
@if $maj_ver == 3 {
  popover.background:not(.emoji-picker) > box.vertical > stack > box.vertical {
    scrolledwindow > viewport.frame {
      border: 1px solid $div_fg;

      > list.background > row.activatable.bookmarks-row {
        color: $sec_fg;
        &:hover,
        &:active,
        &:checked { color: $fg; }

        button.flat {
          min-width: $icon_size;
          min-height: $icon_size;
          padding: rem(4px); // Same as of image.sidebar-icon
          @include radius($r);
        }
      }
    }
  }
}
@else {
  popover:not(.emoji-picker) > box.vertical > stack > box.vertical {
    scrolledwindow > viewport.frame {
      border: 1px solid $div_fg;

      > list.background > row.activatable.bookmarks-row {
        color: $sec_fg;
        &:hover,
        &:active,
        &:checked { color: $fg; }

        button.flat {
          min-width: $icon_size;
          min-height: $icon_size;
          padding: rem(4px); // Same as of image.sidebar-icon
          @include radius($r);
        }
      }
    }
  }
}

// bookmark-tag flowbox-childs (almost hard-coded)
flowboxchild.bookmark-tag-widget {
  color: track($fix_fg, $a_fg_3rd); // unchecked
  font-weight: 500;

  label { margin-bottom: rem($baseline, $sw: 1.0); }

  button { @include radius($r_2); } // revert to square button

 &-selected { color: $sel_fg; } // checked
}

// search result counter labels
.linked > entry.search > entry { // enforce "no-relief" labels
  min-height: unset;
  border: unset;
  background: none;
}

// /************
//  * Seahorse *
//  ************/

window.background box.vertical > paned.horizontal > box.vertical {
  // remove drop-shadow
  > box.vertical > toolbar.primary-toolbar {
    box-shadow: none;
    border-bottom: 1px solid $div_fg;
  }
}

// /**********
//  * Polari *
//  **********/

.polari-room-list { // override labels
  row.activatable {
    font-weight: 500;
    &:not(:hover):not(:active):not(:selected) {
      label,
      image { opacity: 1.0; }
    }

    &.inactive {
      &:not(:hover):not(:active):not(:selected) {
        label,
        image { opacity: $a_fg_3rd; }
      }
    }

    &:selected {
      background-image:
        image(mix($sel_bg, $bg, percentage($a_trk_2)));
      &:dir(ltr) { box-shadow: inset 4px 0 $sel_bg; }
      &:dir(rtl) { box-shadow: inset -4px 0 $sel_bg; }
    }

    label.pending-messages-count {
      background-image: image($sggt_bg);
    }
  }
}

.polari-nick-entry {
  border-image: none;
  font-weight: 700;
}

// bottom-paned entry area
window.background > box.horizontal > overlay > stack > overlay > box.vertical {
  > stack.view { // mimic inline-toolbar styling
    border-style: solid;
    border-width: 1px 0 0;
    border-color: $div_fg;
    background-color: $dark_bg;
  }
}

popover.emoji-picker flowboxchild.emoji {
  // FIXME: why did devs ignore the global emoji theming?
  // Should set hover pseudo-class to child widget node.
  &:hover > widget:not(:hover) label { color: $sel_fg; }
}

// /*************
//  * RhythmBox *
//  *************/

// tweak sidebar styling
.sidebar-paned {
  scrolledwindow {
    @extend %sidebar_template;
    background-image: image($bg);
  }

  treeview.view.sidebar { @extend %sidebar_treeview; }
}

// tweak border and frame in alt-toolbar
window.csd > box.vertical > box.vertical,
window.solid-csd > box.vertical > box.vertical {
  > toolbar.horizontal {
    margin: -1px 0;
    border-top: 1px solid $div_fg;
    background-color: $dark_bg;
    box-shadow: none;
  }

  > frame {
    margin: -1px 0;
    padding: 0;

    > border { border: none; }
  }
}

window.background > box.vertical > box.vertical > toolbar.horizontal {
  // prev/play/next buttons in alternate-mode bottom toolbar
  toolitem .linked.horizontal > button:not(.image-button):not(.text-button) {
    padding: 0 rem($toolitem_size / 4, $sw: 1.0); // revive L/R padding
  }
}

// hard-coded spacing depends on non-scalable unit,
// seems cover-art widget is the most biggest thing?
$album_art: 54px;
$album_art_small: 36px;
$min_button: 24px - (1px * 2);
$toolitem_margin: ($album_art - $min_button) / 2;

window.background > box.vertical > toolbar.primary-toolbar {
  toolitem {
    &:first-child { // 'prev/play/next'
      .linked > button.image-button.raised {
        min-width: $min_button * 2.0;
        min-height: $min_button * 2.0;
        margin: 0;
        padding: 0;
      }
    }

    .linked > button.image-button.raised { // 'shuffle/repeat'
      min-width: $min_button * 1.5;
      min-height: $min_button * 1.5;
      padding: 0;
    }

    button.flat.scale { // 'volume'
      min-width: $min_button;
      min-height: $min_button;
      margin-top: $toolitem_margin;
      margin-bottom: $toolitem_margin;
      padding: 0;
    }

    > box.horizontal:not(.linked) > button.toggle,
    > .linked > button:not(.toggle):not(.raised):not(.flat) {
      min-width: $min_button * 1.5;
      min-height: $min_button * 1.5;
      padding: 0;
    }

    &:last-child { // 'gear'
      button.popup.toggle {
        min-width: $min_button * 1.5;
        min-height: $min_button * 1.5;
        padding: 0;
      }
    }
  }
}

notebook > stack grid.horizontal > grid.horizontal > grid.horizontal {
  button.flat.toggle { // 'edit' and 'browse' button
    &:checked { // draw underline indicator
      background-color: $sel_bg;
      color: $sel_fg;
    }
  }
}

// 'plugins' dialog
dialog.background > box.dialog-vbox.vertical > box.vertical {
  > toolbar.inline-toolbar.horizontal {
    // remove weird margins
    margin: -2px -2px;

    > toolitem {
      box > button {
        min-width: $widget_size - 10.7px;
        min-height: $widget_size - 10.7px;
        padding: 0;
      }

      buttonbox > button {
        min-width: $widget_size - 10.7px;
        min-height: $widget_size - 10.7px;
        padding: 0;
        @include radius($r_2);
      }
    }
  }
}

// bottom toolbar buttons (alternate toolbar mode)
paned.sidebar-paned + box.vertical > frame + toolbar > toolitem {
  > .linked > button,
  > box.horizontal > button.toggle { // prevent jumping button heights
    min-width: $album_art_small;
    min-height: $album_art_small;
    padding: 0;
  }
}

// /********************
//  * Gnome-Calculator *
//  ********************/

window.background {
  > grid.vertical > box.vertical widget,
  grid.math-buttons {
    button {
      min-width: calc(#{rem($widget_size - $txt_button_lr_space)} - 1px * 2);
      @include radius($r_2);

      &:not(.suggested-action) {
        @include button(flat-normal);
        &:hover { @include button(flat-hover); }
        &:active { @include button(flat-active); }
        &:disabled { @include button(flat-disabled); }
        &:checked { @include button(flat-checked); }
        &:checked:disabled { @include button(flat-checked-disabled); }
      }

      &.suggested-action {  // '=' button
        @include radius($r);
      }
    }
  }
}

scrolledwindow {
  &.history-view.frame {
    border-bottom-color: if($variant == dark, track(white, $a_div_2),
                                              $div_fg);

    row.history-entry widget > label { color: $ter_fg; }
  }
}

// /*********
//  * Gedit *
//  *********/

.gedit-bottom-panel-paned {
  .gedit-search-slider {
    @extend %app_slider;
    background-color: track($tooltip_bg, $a_osd);
    color: $fg;
  }
}

paned.titlebar.horizontal {
  headerbar {
    button.flat.toggle.popup:not(.image-button) { // left-pane header button
      @include radius($r_2);

      box > .title {
        margin-top: rem($baseline, $sw: 1.0);
        padding: 0;
      }
    }
  }
}

paned.gedit-bottom-panel-paned + statusbar { // inline-toolbar styling
  padding: $toolbar_padding;
  border-style: solid;
  border-width: 1px 0 0;
  border-color: $div_fg;
  background-color: $dark_bg;

  button.flat { // padding is overridden by (1px 8px 2px 4px)
    min-height: rem($small_widget);

    box {
      &:dir(ltr) { margin: -1px -4px -2px 4px; }
      &:dir(rtl) { margin: -1px 4px -2px -4px; }
    }
  }
}

.gedit-side-panel-paned.horizontal {
  // 'file-browser' pane
  > box.vertical > stack > grid.horizontal {
    @extend %sidebar_template;

    > box.horizontal {  // header-part
      padding: rem($menu_padding) 0;
      border-bottom: 1px solid $div_fg;
    }

    treeview.view { @extend %sidebar_treeview; }
  }
}

.gedit-document-panel { // 'documents' pane
  @extend %sidebar_template;

  row { @extend %sidebar_row_template; }
}

frame.gedit-map-frame > border {
  &:dir(ltr) { border-width: 0 0 0 1px; }
  &:dir(rtl) { border-width: 0 1px 0 0; }
}

// /*****************
//  * Gnome-Builder *
//  *****************/

@if $maj_ver == 3 {
  @if $mnr_ver < 23 {
    // styling for editor search
    frame.gb-search-frame {
      background-image: image($bg);
      padding: rem($menuitem_padding);
      border-style: solid;
      border-color: $div_fg;
      border-width: 0 1px 1px;
      border-radius: 0;

      border { border: none; }
    }

    .gb-search-entry-occurrences-tag {
      color: $dis_fg;
      margin: rem(2px);
      padding: rem(2px);
      border-width: 0;
    }

    // Tweaks for the editortweak popover in the editor.
    editortweak {
      button {
        padding: 0 rem($menuitem_padding) 0 rem($menuitem_padding);
      }

      list row { padding: 0; }
    }

    // Keep search bar and layouttab height in sync.
    layouttabbar > box { min-height: rem($widget_size); }

    eggsearchbar > revealer > box { min-height: rem($widget_size); }

    // Pillbox is used to render "languages" in the greeter.
    pillbox {
      border-radius: $r_2;
      background-color: $bg;
    }

    // Styling in the genesis (create project) perspective.
    genesisperspective stack > box:first-child list row {
      padding: rem(10px);
      border-bottom: 1px solid $div_sld_fg;
      &:last-child { border-bottom: none; }
    }

    // Layout tab and tab bar tweaks
    //
    // The following makes the layout stack header look similar to a tab bar.
    layouttabbar {
      min-height: rem($widget_size);
      padding: $toolbar_padding;
      border-bottom: 1px solid $div_sld_fg;
      background-color: $bg;

      box.horizontal > button {
        &, &.popup.toggle {
          min-width: rem($widget_size);
          min-height: rem($widget_size);
          @include button(flat-normal);
          &:hover { @include button(flat-hover); }
          &:active { @include button(flat-active); }
          &:disabled { @include button(flat-disabled); }
          &:checked { // draw underline
            background-color: $sel_bg;
            color: $sel_fg;
          }
          &:checked:disabled { @include button(flat-checked-disabled); }
        }
      }
    }

    layouttab {
      margin: 4px;
      padding: $toolbar_padding;
      background-color: transparent;

      label { padding: rem($menu_padding); }

      separator.vertical {
        margin: 0 rem($baseline * 2); // expand vertically
        background-color: $div_fg;
      }

      button {
        &, &.popup.toggle {
          min-width: rem($widget_size);
          min-height: rem($widget_size);
          margin: 4px;
          @include radius($r_2);
          @include button(flat-normal);
          &:hover { @include button(flat-hover); }
          &:active { @include button(flat-active); }
          &:disabled { @include button(flat-disabled); }
          &:checked { // draw underline
            background-color: $sel_bg;
            color: $sel_fg;
          }
          &:checked:disabled { @include button(flat-checked-disabled); }
        }
      }

      // close button styling for layouttab.
      > box > button.close {
        @include radius($r_2);
        min-width: rem($widget_size);
        min-height: rem($widget_size);
        @include button(flat-normal);
        &:hover { @include button(flat-hover); }
        &:active { @include button(flat-active); }
        &:disabled { @include button(flat-disabled); }
      }
    }
  }
}

layout {
  // hide top/bottom pane-separator
  border-width: 0 1px 0;
  border-style: none solid none;
  border-color: $div_sld_fg;
  // revive top-edge border with box-shadow
  box-shadow: inset 0 -1px $div_sld_fg;

  -PnlDockBin-handle-size: 1;
}

eggsearchbar box.search-bar { background-color: $dark_bg; }

%omnibar_entry {
  // enforce inverted label color
  &:not(:hover):not(:active) > entry {
    @if $variant == mixed {
      background-image:
        image(mix($inv_fg, $inv_base, percentage($a_trk_1 / 2)));
      color: $inv_sec_fg;
      caret-color: $inv_sec_fg;

      label { color: $inv_sec_fg; }
    }
    @else {
      color: $sec_fg;
      caret-color: $sec_fg;

      label { color: $sec_fg; }
    }
  }

  &:hover > entry {
    @if $variant == mixed {
      background-image:
        image(mix($inv_fg, $inv_base, percentage($a_trk_1 / 2)));
      color: $inv_fg;
      caret-color: $inv_fg;

      label { color: $inv_fg; }
    }
    @else {
      color: $fg;
      caret-color: $fg;

      label { color: $fg; }
    }
  }

  &:active > entry {
    &, &:focus {
      border-color: $sel_bg;
      background-image: image($sel_bg);
      color: $sel_fg;
      caret-color: $sel_fg;

      label { color: $sel_fg; }
    }
  }
}

omnibar.linked {
  &, // fullscreen-mode (>= 3.28)
  .titlebar & { @extend %omnibar_entry; } // window-ed mode
}

@if $maj_ver == 3 {
  @if $mnr_ver > 23 { // >= 3.31.90
    entry > overlay { @extend %entry_overlay; }
  }
}
@else {
  entry > overlay { @extend %entry_overlay; }
}

%entry_overlay {
  // Gtk-2-ed like arrow up/down 12px buttons!?
  box.pan.vertical { margin: -3px 0; }

  progressbar.bottom { // expand progressbar
    trough, progress {
      min-height: calc(#{rem($widget_size)} - 2px * 2);
      &:dir(ltr) { @include radius($r 0 0 $r, none); }
      &:dir(rtl) { @include radius(0 $r $r 0, none); }
    }

    trough { background-color: transparent; }

    progress { background-color: track($acc_bg, $a_trk_out); }
  }

  // child buttons have fixed 24px min-height/width via shared-omnibar.css
  notification > box.horizontal { margin: -3px 0; }
}

%tabstrip {
  min-height: rem($small_widget);
  padding: $toolbar_padding rem($ref_size);
  border-bottom: 1px solid $div_sld_fg;
  background-color: $bg;
}

%tabstrip_tab {
  color: $ter_fg;
  font-weight: 500;
  box-shadow: inset 0 -1px $trk_out_fg;
  &:hover {
    color: $fg;
    box-shadow: inset 0 -2px $trk_out_fg;
  }
  &:checked {
    color: $fg;
    box-shadow: inset 0 -2px $sel_bg;
  }
}

tabstrip,
docktabstrip { @extend %tabstrip; }

tabstrip tab,
docktabstrip docktab { @extend  %tabstrip_tab; }

@if $maj_ver == 3 {
  @if $mnr_ver < 23 {
    dockstack > stack { // treeviews inside the left/right layoutpane
      > dockwidget treeview.project-tree.view,
      > devhelppanel treeview.view {
        background-color: $bg;
        font-weight: 500;
        &:selected { @extend %selected_items; }
      }
    }
  }
}

headerbar > box > box.linked {
  > button.image-button.popup.toggle {
    &.run-arrow-button {
      min-width: 0;
      padding-left: 0;
      padding-right: 0;
    }
  }
}

popover {
  @if $maj_ver == 3 {
    > list > row.activatable > box.horizontal {
      > label { // add lateral gaps
        &:dir(ltr) { margin-left: rem($entry_lr_space); }
        &:dir(rtl) { margin-right: rem($entry_lr_space); }
      }
    }
  }
  @else {
    > contents > list > row.activatable > box.horizontal {
      > label { // add lateral gaps
        &:dir(ltr) { margin-left: rem($entry_lr_space); }
        &:dir(rtl) { margin-right: rem($entry_lr_space); }
      }
    }
  }
}

greeter > box.vertical > stack {
  gitclonewidget > overlay > box.vertical,
  flatpakclonewidget > overlay > box.vertical {
    margin: -36px; // kill hard-coded margins
    padding: 36px;
  }

  // project selections
  > box.vertical > stack > box.vertical > scrolledwindow {
    frame > list {
      // override shared.css
      row.activatable:not(:last-child) {
        border-image: image($div_fg) 0 0 1 / 0 0 1px;
      }
    }
  }
}

preferences > box.horizontal {
  > box.vertical { // side-pane
    @extend %sidebar_template;

    > entry { margin: 0 4px; } // stop touching L/R edges

    > stacksidebar.sidebar {
      list {
        background-color: transparent;

        // enlarge padding
        row.activatable {
          min-height: rem($widget_size);
          padding: 0 rem(13.3px);
        }
      }
    }
  }

  preferencesgroup {
    > box.vertical > label { // titles
      color: $ter_fg;
      font-weight: 700;
    }

    scrolledwindow > viewport.frame > list {
      // override shared.css
      row.activatable:not(:last-child) {
        border-image: image($base) 0 0 1 / 0 0 1px;
      }
    }
  }
}

// info-bars beneath GtkHeaderBar
window.background.workbench box.message-box.vertical {
  // hide bottom border
  infobar.horizontal { border-bottom-width: 0; }
}

ide {
  // left-pane sidebar?
  &editorsidebar {
    @extend %sidebar_template;
    background-image: image($bg);
  }

  // editor-pane headers?
  &layoutstackheader { // damned upstream CSS
    border-bottom: 1px solid $div_fg;
    box-shadow: inset 0 0 0 26px track($fix_base, 0.05);

    button {
      min-width: 26px;
      min-height: 26px;

      label { padding-bottom: rem($baseline, $sw: 1.0); }
    }
  }
}

dzl {
  &multipaned {
    > box.vertical {
      // draw borders for pane-grip
      border-top: 1px solid $div_fg;
    }

    // 'open-pages' list
    list.open-pages { background-color: transparent; }

    // no need to highlighten headers
    buildpanel notebook > header.top { background-color: transparent; }
  }

  &menubuttonsection { // child elements in their GtkPopovers
    // kill ugly upstream CSS's parent margins
    &:only-child { margin: -$popover_padding; }
    &:first-child { margin: (-$popover_padding) (-$popover_padding) 0; }
    &:last-child { margin: 0 (-$popover_padding) (-$popover_padding); }
  }

  &preferencesview {
    entry.preferences-search.search {
      // add 1px bottom shadow as a border
      box-shadow: inset 0 -1px $div_fg;
    }

    stacksidebar.sidebar viewport.frame > list {
      @extend %sidebar_template;
      background-image: image($bg);

      row.activatable {
        min-height: rem($widget_size);
        padding: 0 rem(13.3px);
      }
    }
  }
}

headerbar button.dzlmenubutton.popup.toggle {
  &:not(.flat):not(.suggested-action):not(.destructive-action) {
    &:not(.titlebutton):not(.selection-menu):not(.text-button):not(.lock) {
      &:not(.color):not(.image-button) {
        @include radius($r_2, none);
        padding: 0 rem($txt_button_lr_space / 2);
      }
    }
  }
}

list {
  popover.messagepopover box.popover-content-area &,
  popover.omnibar box.vertical & {
    // list node at the bottom?
    margin: $popover_padding;
    background-color: $dark_bg;
  }
}

popover.transfers {
  viewport.frame > list > row { padding: $toolbar_padding; }
}

@if $maj_ver == 3 {
  window.background.workbench > popover.menu { // right-most popover
    > stack { // reduce embedded margins more
      margin: -(12px - 2px) -12px -12px;
    }
  }
}
@else {
  window.background.workbench > popover { // right-most popover
    > contents.menu > stack { // reduce embedded margins more
      margin: -(12px - 2px) -12px -12px;
    }
  }
}

window.workbench > stack.titlebar > stack > headerbar > box.horizontal {
  > button.dzlmenubutton.popup.toggle {
    padding: 0 rem($txt_button_lr_space / 2);

    image { padding: 0 rem($txt_button_lr_space / 2); }
  }

  > box.horizontal > button.popup.toggle { // radial-progress widget
    > widget { color: $acc_fg; }

    &:checked > widget { color: $sel_fg; }
  }
}

button.dzlmenubuttonitem.check { // menuitem buttons
  @include transition(reset); // unset transition
  font-weight: 400; // reset weight

  box > image { opacity: $a_fg_2nd; }

  label { padding: rem(5.3px) 0 rem(6.7px); }

  // :checked inside the popover menus!?
  &:checked label { // keep default label color
    color: $sec_fg;

    &.dim-label { color: $sec_fg; }
  }
}

// /***************
//  * Gnome-Music *
//  ***************/

// side-bar styling
@if $maj_ver == 3 {
  @if $mnr_ver < 23 {
    .side-panel {
      .view {
        &,
        row.activatable { font-weight: 500; }
      }
    }
  }
  @else {
    overlay > stack.background stack grid scrolledwindow.sidebar {
      &:dir(ltr) { border-right: 1px solid $div_fg; }
      &:dir(rtl) { border-right: 1px solid $div_fg; }

      list {
        @extend %sidebar_template;
      }
    }
  }
}
@else {
  overlay > stack.background stack grid scrolledwindow.sidebar {
    &:dir(ltr) { border-right: 1px solid $div_fg; }
    &:dir(rtl) { border-right: 1px solid $div_fg; }

    list { @extend %sidebar_template; }
  }
}

// right-pane of AlbumWidget
.discsongsflowbox > flowboxchild {
  // increase the vertical spacing
  margin: rem($menuitem_padding, $sw: 1.0) 0;

  check:only-child { // 'songs' selection-mode check
    margin: 0;
    padding: 0;
    animation: none; // unset animations
  }
}

// /******************
//  * Gnome-Contacts *
//  ******************/

// side-bar styling
window grid.titlebar + overlay > grid.horizontal > frame {
  > border {
    &:dir(ltr) { border-width: 0 1px 0 0; }
    &:dir(rtl) { border-width: 0 0 0 1px; }
  }

  > grid scrolledwindow > viewport.frame {
    @extend %sidebar_template;
  }
}

list.contacts {
  @if $maj_ver == 3 {
    @if $mnr_ver < 23 {
      &-view {
        row.activatable { @extend %sidebar_row_template; }
      }
    }
  }

  &-contact-list { // >= 3.27.90
    row.activatable { @extend %sidebar_row_template; }
  }

  &-contact-list { border-top: 1px solid $div_fg; }
}

list.contacts-view {
  // hide horizontal separator
  separator {
    min-height: 0;
    border-color: transparent;
    background-color: transparent;
  }
}

scrolledwindow.contacts-contact-form {
  // override stock style.css
  background-image: image($base);
}

@if $maj_ver == 3 {
  @if $mnr_ver > 23 { // >= 3.31.90
    hdyleaflet > overlay > stack { background-color: $base; }
  }
}
@else {
  hdyleaflet > overlay > stack { background-color: $base; }
}

// /**********
//  * Evince *
//  **********/

window.background {
  > box.vertical > box.horizontal {
    > widget > label { // annotation title
      color: $fix_fg;
      font-weight: 700;
    }
  }
}

window.background.csd > box.vertical + headerbar.titlebar {
  > box.vertical { // 'Open...' button
    + button:not(.suggested-action):not(.destructive-action) {
      &:not(.titlebutton):not(.selection-menu) {
        &:not(.text-button):not(.lock):not(.color):not(.image-button) {
          padding: 0 rem($txt_button_lr_space);
          @include radius($r_2, none);
        }
      }
    }
  }
}


// plugin mode in Ephy
window.background > widget > window.background > box.vertical {
  > toolbar.horizontal {
    border-top: 1px solid $div_fg;
    background-color: $bg;
  }

  > scrolledwindow {
    scrollbar {
      &,
      &.overlay-indicator,
      trough {
        background-color: $bg;
        @include transition(reset);
      }

      slider { @include transition(reset); }
    }

    evview.content-view.view { @include transition(reset); }
  }
}

// /**************
//  * Gnome-Logs *
//  **************/

window.background > box.vertical box.horizontal {
  list.categories { // side-pane
    @extend %sidebar_template;
    border: none;
    color: $sec_fg;

    row.activatable.category { // use side-bar styling
      // paddings in row were hard-coded with crazy large values...
      @extend %sidebar_row_template;

      > label {
        padding-left: 0;
        padding-right: 0;
      }
    }
  }

  > box.vertical > scrolledwindow > viewport.frame > list { // right-pane
    > separator {
      background-color: transparent; // hide single-line separators

      &.compressed-rows-group-separator { // use opaque color
        background-image : image($div_sld_fg);
      }
    }

    // > 3.25.90
    row.event.activatable {
      color: $sec_fg;
      &:hover,
      &:active { color: $fg; }
      &:not(:disabled) { // for quicker response
        background-image: none;
        transition-duration: $tr_d_sht;
        transition-delay: $tr_d_non;
        animation: none;
      }

      label.compressed-entries-label { // hard-coded background-color?
        background-image: image($sggt_bg);
        color: $sel_fg;
        font-weight: 700;
      }

      &.compressed-row {
        background-image: image($bg);
        color: $fg;
        &:hover {
          background-image: image(mix($fg, $bg, percentage($a_trk_1 / 2)));
          color: $fg;
        }
        &:active {
          &, &:focus {
            background-image: image(mix($fg, $bg, percentage($a_trk_1)));
            color: $fg;
          }
        }

        &.popover-activated-row {
          background-image: image($sel_bg);
          color: $sel_fg;
        }

        &-header {
          background-image: image($base); // stop highlighting
          color: $sel_label;
          &:not(:disabled) {
            transition-property: opacity, // exclude background-color
                                 border-image,
                                 background-image,
                                 box-shadow;
            transition-duration: $tr_d_sht;
            animation: none;
          }
          &:hover {
            background-image: image(mix($sel_label,
                                        $base, percentage($a_trk_1 / 2)));
          }
          &:active {
            &, &:focus {
              background-image: image(mix($sel_label,
                                          $base, percentage($a_trk_1)));
              color: $sel_label;
            }
          }

          label.compressed-entries-label {
            background-image: image($sel_bg);
            color: $sel_fg;
            transition-duration: $tr_d_non;
          }
        }
      }
    }
  }
}

@if $maj_ver == 3 {
  @if $mnr_ver > 23 {
    button.title-menu-button.flat {
      label.title {
        margin-top: if($ref_weight < 1.0, 0, rem($baseline * 2));
        margin-bottom: 0;
      }

      label.subtitle { margin: 0; }
    }
  }
}
@else {
  button.title-menu-button.flat {
    label.title {
      margin-top: if($ref_weight < 1.0, 0, rem($baseline * 2));
      margin-bottom: 0;
    }

    label.subtitle { margin: 0; }
  }
}

// /******************
//  * Gnome-Terminal *
//  ******************/

terminal-window {
  // FIXME: In XWayland mode, downstream 'transparency' patch causes
  // solid outer margin artifact when users keep enabling transparent
  // background.
  &.csd.background { background-color: transparent; }

  @if $maj_ver == 3 {
    @if $mnr_ver < 23 {
      &.background:not(.csd),
      vte-terminal {
        background-color: if($variant == mixed, $inv_base,
                                                $base);
        color: if($variant == mixed, $inv_fg, $fg);
      }

      @if $variant == mixed {
        scrollbar {
          background-color: track($inv_base, $a_fg_3rd);

          slider {
            background-color: track($inv_fg, $a_fg_3rd * $a_fg_3rd);
            &:hover {
              background-color: track($inv_fg, $a_fg_2nd * $a_fg_3rd);
            }
            &:active { background-color: $inv_fg; }
          }
        }
      }
    }
  }
}

@if $maj_ver == 3 {
  @if $mnr_ver == 22 {
    window.background:not(.csd) { // preferences window (3.27 < ver < 3.31)
      box.horizontal > frame > scrolledwindow > viewport.frame > list {
        @extend %term_pref_window;
      }
    }
  }
  @if $mnr_ver > 23 {
    window.background.csd { // preferences window (>= 3.31)
      box.horizontal > frame > scrolledwindow > viewport.frame > list {
        @extend %sidebar_template;
        @extend %term_pref_window;

        row.activatable button.flat.popup.toggle {
          @extend %pref_down_arrow;
        }
      }
    }
  }
}
@else {
  window.background.csd { // preferences window (>= 3.31)
    box.horizontal > frame > scrolledwindow > viewport.frame > list {
      @extend %sidebar_template;
      @extend %term_pref_window;

      row.activatable button.flat.popup.toggle {
        @extend %pref_down_arrow;
      }
    }
  }
}

%term_pref_window {
  > row.activatable {
    padding: 0; // unset padding;

    > box.horizontal > label { // indentations
      &:dir(ltr) { margin-left: rem($ref_size, $sw: 1.0); }
      &:dir(rtl) { margin-right: rem($ref_size, $sw: 1.0); }
    }

    > box.horizontal > stack > button.popup.toggle {
      min-width: rem($small_widget);
      min-height: rem($small_widget);
      padding: 0;
      @include radius($r);
    }
    &:selected { @extend %selected_sidebar_row; }
  }

  > box.horizontal {
    label { color: $ter_fg; } // titles

    > stack > button.image-button {
      min-width: rem($small_widget);
      min-height: rem($small_widget);
      padding: 0;
    }
  }
}

%pref_down_arrow {
  @include button(flat-normal, $tc: $sel_label);
  &:hover { @include button(flat-hover, $tc: $sel_label); }
  &:active { @include button(flat-active, $tc: $sel_label); }
  &:checked { @include button(flat-checked, $tc: $sel_label); }
}

// /*****************
//  * Gnome-Weather *
//  *****************/

frame#locations-frame > border { // hide double borders
  border: none;
}

frame#weather-page-content-view {
  .linked.osd.stack-switcher {
    background: transparent;

    > button.radio.text-button { // remove underlines
      @include radius(0);
      &:checked {
        &, &:hover {
          border-image: radial-gradient(circle farthest-corner at center,
                                        currentColor 100%,
                                        transparent)
                                        0 0 2 / 0 0 2px;
        }
      }
    }
  }

  button.osd {
    min-width: rem($widget_size);
    min-height: rem($widget_size);
    padding: rem($txt_button_lr_space / 2);
    @include radius($r);
  }

  frame#weekly-forecast-frame { background: transparent; }
}

frame#weather-page-content-view { // condition-specific
  @each $_condition,
        $_label_1_color,
        $_label_2_color,
        $_frame_mask,
        $_label_alpha,
        $_mask_alpha,
        $_mix_pct in
  (clear,
    $fix_fg, $sel_fg, $sel_fg, $a_fg_3rd, $a_trk_1, 100%),
  (few-clouds,
    $fix_fg, $sel_fg, $sel_fg, $a_fg_3rd, $a_trk_1, 10%),
  (showers,
    $sel_fg, $fix_fg, $fix_fg, $a_fg_2nd, $a_trk_1, 50%),
  (showers-scattered,
    $sel_fg, $fix_fg, $fix_fg, $a_fg_2nd, $a_trk_1, 50%),
  (storm,
    $sel_fg, $fix_fg, $fix_fg, $a_fg_2nd, $a_trk_1, 50%),
  (overcast,
    $fix_fg, $sel_fg, $inv_fg, $a_fg_2nd, $a_fg_3rd, 75%),
  (fog,
    $fix_fg, $sel_fg, $inv_fg, $a_fg_2nd, $a_fg_3rd, 75%),
  (snow,
    $sel_fg, $link_fg, $sel_fg, $a_fg_3rd, $a_trk_1, 80%),
  (few-clouds-night,
    $sel_fg, $link_fg, $sel_fg, $a_fg_3rd, $a_trk_1, 80%),
  (clear-night,
    $inv_acc_fg, $sel_fg, $sel_fg, $a_fg_2nd, $a_trk_1, 100%) {

    &.weather-#{$_condition} {
      button.radio.text-button,
      button.osd {
        @include button(flat-normal,
                        $tc: track($_label_1_color, $_label_alpha));
        background-image: none; // disable ink reactions
        box-shadow: none; // unset lines
        &:hover {
          color: #{$_label_1_color};
          @include button(flat-hover, $tc: $_label_1_color);
        }
        &:active {
          // FIXME: ink reaction can't be rendered smoothly,
          // so fill background instead.
          background-color: track($_label_1_color, $a_trk_2);
          color: #{$_label_1_color};
          animation: none;
        }
        &:checked {
          @include button(flat-normal, $tc: $_label_1_color);
        }
      }

      frame#weekly-forecast-frame {
        background-image: image(track($_frame_mask, $_mask_alpha));

        * { color: mix($_label_1_color, $_label_2_color, $_mix_pct); }
      }
    }
  }
}

// /**************
//  * Gnome-Todo *
//  **************/

window.org-gnome-Todo headerbar > box.horizontal {
  // 'new-list' text-button
  > button.toggle.popup {
    &:not(.suggested-action):not(.destructive-action) {
      &:not(.titlebutton):not(.selection-menu) {
        &:not(.text-button):not(.lock):not(.color):not(.image-button) {
          @include radius($r_2, none);

          > label { padding: 0 rem($txt_button_lr_space / 2); }
        }
      }
    }
  }
}

@if $maj_ver == 3 {
  window > popover > stack > grid > button.text-button {
    // prevent unwanted truncation of drop-shadows
    margin: 2px 6px 12px;
  }
}
@else {
  window > popover > contents > stack > grid > button.text-button {
    // prevent unwanted truncation of drop-shadows
    margin: 2px 6px 12px;
  }
}

// /************
//  * Gtk-Demo *
//  ************/

.background.csd > box.horizontal > frame > scrolledwindow {
  // side-bar styling
  @extend %sidebar_template;

  treeview.view {
    @extend %sidebar_treeview;
    &:selected:last-child {
      &:dir(ltr) { @include radius(0 $r $r 0); }
      &:dir(rtl) { @include radius($r 0 0 $r); }
    }
  }
}

// /***************
//  * Gnome-Disks *
//  ***************/

.background.csd > box.vertical > paned.horizontal > scrolledwindow,
.background.solid-csd > box.vertical > paned.horizontal > scrolledwindow {
  // side-bar styling
  @extend %sidebar_template;

  treeview.view {
    @extend %sidebar_treeview;
    &:selected:last-child {
      &:dir(ltr) { @include radius(0 $r $r 0); }
      &:dir(rtl) { @include radius($r 0 0 $r); }
    }
  }
}

// /************************
//  * Gnome-Control-Center *
//  ************************/

// users section
stack > box.vertical widget overlay grid.horizontal > stack {
  // prevent unwanted truncation of shadows
  padding: $shadow_margin_3;
}

// carousel widgets
.carousel-arrow-container.bottom.horizontal {
  // prevent double density border
  margin-bottom: -1px;
}

button.carousel-item.flat.menu.radio:focus {
  // outlines cause unwanted region-violations on avatar GtkImages,
  // so let's hide them
  outline-width: 0;
}

scrolledwindow.view > viewport.frame > stack { // left-pane
  > list, // > 3.25.90
  > box.vertical > entry.search + list { // > 3.33.90
    @extend %sidebar_template;

    > row.activatable {
      padding: 0; // unset padding
      color: $sec_fg;
      font-weight: 500;

      image.dim-label { opacity: $a_fg_2nd; } // tone up icons

      label,
      image { color: $sec_fg; }

      &:hover,
      &:active {
        color: $fg;

        label,
        image { color: $fg; }
      }

      &:selected {
        &:dir(ltr) { @include radius(0 $r $r 0); }
        &:dir(rtl) { @include radius($r 0 0 $r); }

        &, &:focus { outline-width: 0; } // unset focus outlines

        &, &:hover {
          background-color: $trk_bg;
          color: $sel_label;

          label,
          image { color: $sel_label; }
        }
      }
    }
  }
}

dialog.background.csd {
  > headerbar.titlebar {
    > label:not(.title):not(.subtitle) {
      color: if($variant == mixed, $inv_fg, $fg);
      font-weight: 700;
    }
  }
}

@if $maj_ver == 3 {
  @if $mnr_ver > 23 {
    flowboxchild > overlay > image + button.image-button.osd.remove-button {
      // subtract app's CSS T/B padding
      min-height: calc(#{rem($widget_size)} - 1px * 2);
    }
  }
}
@else {
  flowboxchild > overlay > image + button.image-button.osd.remove-button {
    // subtract app's CSS T/B padding
    min-height: calc(#{rem($widget_size)} - 1px * 2);
  }
}

// /****************
//  * Dconf-Editor *
//  ****************/

.dconf-editor {
  > headerbar.titlebar > box.pathbar { // legacy
    min-height: $icon_size;
    margin: $toolbar_padding 0;
    padding: 0 rem($menuitem_padding);

    > button {
      min-height: $icon_size;
      margin: $toolbar_padding 0;
      padding: 0;
      @include radius($r_2);

      > .item {
        @if $maj_ver == 3 {
          @if $mnr_ver < 21 { margin: (-$toolbar_padding) 0; }
          @else { margin: 0; }
        }
        @else { margin: 0; }
        padding: 0 rem($menuitem_padding);
        border: 0 none transparent;
        color: if($variant == mixed, $inv_sec_fg, $sec_fg);
        font-weight: 500;
      }

      &:hover,
      &:active,
      &:checked,
      &.active { // '.active' class = :checked class
        color: if($variant == mixed, $inv_fg, $fg);

        > .item { color: if($variant == mixed, $inv_fg, $fg); }
      }
      &:disabled {
        color: if($variant == mixed, $dis_inv_fg, $dis_fg);

        > .item { color: if($variant == mixed, $dis_inv_fg, $dis_fg); }
      }
    }

    // slash symbols
    > label {
      @if $maj_ver == 3 {
        @if $mnr_ver < 23 {
          color: if($variant == mixed, $inv_ter_fg, $ter_fg);
        }
        @else { // hack for stock dconf-editor.css
          @if $variant == mixed {
            &:not(:backdrop) { text-shadow: 1px 0 $inv_ter_fg; }
          }
        }
      }
      @else {
        @if $variant == mixed {
          &:not(:backdrop) { text-shadow: 1px 0 $inv_ter_fg; }
        }
      }
    }
  }

  list.properties-list > row.activatable {
    &:hover,
    &:active { // unset hover/active effects
      background-image: none;
      animation: none;
    }
  }

  list.keys-list { // >= 3.27.91
    > grid.horizontal > separator,
    > grid.vertical > label.header-label + separator { // hide separators
      all: unset;
    }

    > row.key-row:not(:first-child) { // move separator lines into child rows
      border-top: 1px solid $div_fg;
    }

    > grid.vertical { // grid node for headers
      background-color: $bg;

      // increase title height
      label.header-label { min-height: rem($widget_size); }
    }
  }

  @if $maj_ver == 3 { // >= 3.31.90
    @if $mnr_ver > 23 {
      headerbar box.centerwidget { @extend %dconf_pathbar_box; }

      &.maximized box.centerwidget box.pathbar {
        @extend %dconf_maxd_pathbar_box;
      }
    }
  }
  @else {
    headerbar box.centerwidget { @extend %dconf_pathbar_box; }

    &.maximized box.centerwidget box.pathbar {
      @extend %dconf_maxd_pathbar_box;
    }
  }

}

%dconf_pathbar_box {
  box.pathbar button { // stock CSS has 6px T/B margins!?
    &:not(.flat):not(.suggested-action):not(.destructive-action) {
      &:not(.titlebutton):not(.selection-menu):not(.text-button) {
        &:not(.lock):not(.color):not(.image-button) {
          min-height: rem($ref_size, $sw: 1.0); // shrink height
        }
      }
    }

    label.item {
      margin: -6px 0; // compensate unneeded parent T/B margns
      // mask stock 3px border indicators
      border-image: if($variant == mixed, image($inv_dark_bg),
                                          image($dark_bg))
                      0 0 1 / 0 0 1px stretch;

      &:backdrop {
        border-image: if($variant == mixed, image($inv_bg), image($bg))
                        0 0 1 / 0 0 1px stretch;
      }
    }

    &:hover:not(.active) label.item {
      color: if($variant == mixed, $inv_fg, $fg);
      box-shadow: inset 0 -2px if($variant == mixed,
                                 track($inv_fg, $a_trk_out),
                                 track($fg, $a_trk_out));
    }

    &.active label.item { // redraw underline indicators
      color: if($variant == mixed, $inv_fg, $fg);
      box-shadow: inset 0 -2px $sel_bg;
    }
  }
}

%dconf_maxd_pathbar_box {
  // this isn't perfect, but covering 99% unneeded borders at least...
  border-image: if($variant == mixed, image($inv_dark_bg), image($dark_bg))
                  0 0 2 / 0 0 2px stretch;
  background-image: if($variant == mixed, image($inv_dark_bg),
                                          image($dark_bg));
  &:backdrop {
    border-image: if($variant == mixed, image($inv_bg), image($bg))
                    0 0 2 / 0 0 2px stretch;
    background-image: if($variant == mixed, image($inv_bg),
                                            image($bg));
  }

  label,
  image { color: if($variant == mixed, $inv_sec_fg, $sec_fg); }

  button:hover label.item,
  button.active label.item { color: if($variant == mixed, $inv_fg, $fg); }

  > label { color: if($variant == mixed, $inv_ter_fg, $ter_fg); }
}

// /*******************
//  * Gnome-Documents *
//  *******************/

window.background > grid.horizontal.titlebar {
  // search-bar revealer
  @if $maj_ver == 3 {
    box.vertical > headerbar + searchbar { background-color: $dark_bg; }
  }
  @else {
    box.vertical > headerbar + searchbar > revealer > box {
      background-color: $dark_bg;
    }
  }
}

// /********************
//  * Gnome-Characters *
//  ********************/

// side-pane styling
scrolledwindow > viewport.frame list.categories {
  @extend %sidebar_template;

  > row.category.activatable {
    font-weight: 500;
    &:selected {
      &:dir(ltr) { @include radius(0 $r $r 0); }
      &:dir(rtl) { @include radius($r 0 0 $r); }

      &, &:focus { outline-width: 0; } // unset focus outlines

      &, &:hover {
        background-color: $trk_bg;
        color: $sel_label;

        image.category-icon,
        label.category-label { color: $sel_label; }
      }
    }
  }
}

// right-pane styling
scrolledwindow.character-list-scroll {
  > scrollbar { // always use light-variant
    background-color: transparent;

    slider {
      background-color: track($ter_fix_fg, $a_fg_3rd);
      &:hover {
        background-color: track($sec_fix_fg, $a_fg_3rd);
      }
      &:active { background-color: $fix_fg; }
      &:disabled { opacity: $a_fg_bdp; }
    }

    &.overlay-indicator {
      &:not(.dragging):not(.hovering) slider {
        background-color: track($ter_fix_fg, $a_fg_3rd);
      }
    }
  }
}

// /******************
//  * Gnome-Software *
//  ******************/

// get more uniformity for all 'All', 'Installed', 'Updates' buttons
buttonbox.linked > button.toggle.toolbar-primary-buttons-software {
  &:first-child,
  &:last-child,
  &:not(:first-child):not(:last-child) {
    min-height: rem($widget_size);
    border: none;
    @include radius(0);
  }

  min-width: rem($widget_size * 3);
  box-shadow: inset 0 -1px $trk_out_fg;
  &:not(:hover):not(:active):not(:checked):not(:disabled) {
    color: if($variant == mixed, $inv_sec_fg, $sec_fg);
  }
  @if $variant == mixed {
    @include button(flat-normal, $tc: $inv_fg);
    @include ink-reaction(
      normal, $fc: $inv_fg, $tr: ink-normal-dec);
    &:hover { @include button(flat-lined-hover, $tc: $inv_fg); }
    &:active {
      @include button(flat-active, $tc: $inv_fg);
      @include ink-reaction(
        active-dec, $fc: $inv_fg, $tr: ink-active-dec);
    }
    &:disabled {
      @include button(flat-disabled, $tc: $inv_fg);
    }
    &:checked {
      @include button(flat-lined-checked, $tc: $inv_sel_label);
      &:hover { @include button(flat-hover, $tc: $inv_sel_label); }
    }
  }
  @else {
    @include button(flat-normal, $tc: $fg);
    @include ink-reaction(normal, $fc: $fg, $tr: ink-normal-dec);
    &:hover { @include button(flat-lined-hover, $tc: $fg); }
    &:active {
      @include button(flat-active, $tc: $fg);
      @include ink-reaction(active-dec, $fc: $fg, $tr: ink-active-dec);
    }
    &:disabled {
      @include button(flat-disabled, $tc: $fg);
    }
    &:checked {
      @include button(flat-lined-checked, $tc: $sel_label);
      &:hover { @include button(flat-hover, $tc: $sel_label); }
    }
  }

  > box.horizontal > label.text-button {
    border: none;
    background: none;
    color: if($variant == mixed, $inv_sec_fg, $sec_fg);
    font-weight: 500;
  }

  &:hover,
  &:active {
    color: if($variant == mixed, $inv_fg, $fg);

    > box.horizontal > label.text-button {
      color: if($variant == mixed, $inv_fg, $fg);
    }
  }

  &:checked {
    &, &:hover {
      color: if($variant == mixed, $inv_sel_label, $sel_label);

      > box.horizontal > label.text-button {
        color: if($variant == mixed, $inv_sel_label, $sel_label);
      }
    }
  }

  > box.horizontal > label.counter-label {
    margin: 2px 0; // make slight T/B spaces
    font-weight: 700;
  }
}

window.background > box.vertical > overlay > stack > widget > stack {
  // "Installed" stack
  > box.vertical > scrolledwindow > viewport.frame > widget > list {
    background-color: $bg; // override $base_color

    // use asymmetrical separators
    > separator {
      &:dir(ltr) { border-left: $icon_size * 6 solid transparent; }
      &:dir(rtl) { border-right: $icon_size * 6 solid transparent; }
    }
  }

  // "Updates" stack
  widget > box.vertical.app-list {
    // override $base_color
    background-image: image($bg);

    > box.vertical > list { background-color: $bg; }

    // use asymmetrical separators
    separator {
      &:dir(ltr) { border-left: $icon_size * 6 solid transparent; }
      &:dir(rtl) { border-right: $icon_size * 6 solid transparent; }
    }
  }
}

// sidebar-pane styling
scrolledwindow.category-sidebar.frame > viewport.frame > list {
  @extend %sidebar_template;
  margin-top: -4px; // hide weird header-gap

  > row.activatable {
    color: $sec_fg;
    font-weight: 500;
    &:hover {
      background-color: $trk_bg;
      color: $fg;
    }
    &:selected { @extend %selected_sidebar_row; }
  }
}

%gnome-software_round_button,
button.round-button { // categories expander button
  // > 3.25.90, dropped from upstream CSS
  min-height: 32px;
  min-width: 32px;
  padding: 0;
  border: 0 none transparent;
  @include radius($r);
}

@if $maj_ver == 3 {
  @if $mnr_ver > 23 { // >= 3.32.0, origin-box container
    window.background.csd > headerbar.titlebar > box.horizontal {
      > label.dim-label + button.popup.toggle {
        @extend %origin_box_button; // enforce text-and-image-button styling
      }
    }
  }
}
@else {
  window.background.csd > headerbar.titlebar > box.horizontal {
    > label.dim-label + button.popup.toggle { @extend %origin_box_button; }
  }
}

%origin_box_button {
  &:not(.flat):not(.text-button):not(.image-button) {
    &:dir(ltr), &:dir(rtl) { // specificity bump
      @include radius($r_2, none);
      padding: 0 rem($txt_button_lr_space / 2);

      label,
      image { padding: 0 rem($txt_button_lr_space / 2); }
    }
  }
}

// /****************
//  * Gnome-Photos *
//  ****************/

.photos-entry-tag { @extend .entry-tag; }

headerbar.titlebar > widget > stack > button:not(.flat) {
  &:not(.suggested-action):not(.destructive-action) {
    &:not(.titlebutton):not(.selection-menu) {
      &:not(.text-button):not(.lock):not(.color):not(.image-button) {
        // revert to image-text-button
        @include radius($r_2, none);

        image {
          &:dir(ltr) { padding-left: rem($txt_button_lr_space); }
          &:dir(rtl) { padding-right: rem($txt_button_lr_space); }
        }

        label {
          &:dir(ltr) { padding-right: rem($txt_button_lr_space); }
          &:dir(rtl) { padding-left: rem($txt_button_lr_space); }
        }
      }
    }
  }
}

// /******************
//  * Gnome-Calendar *
//  ******************/

// 'year-view' sidebar
stack.view > calendar-view.year-view > box.vertical {
  background-color: $bg;

  > stack { // unset presets
    > box.sidebar,
    > scrolledwindow > viewport.frame > list.sidebar {
      border: none;
      background-color: transparent;
      box-shadow: none;
    }
  }

  // enforce action-button styling for 'Add event...' button
  > button.text-button {
    @extend %action-area-button;

    // add missing borders
    &:dir(ltr) { border-left: 1px solid $div_fg; }
    &:dir(rtl) { border-right: 1px solid $div_fg; }
  }
}

dialog.background {
  > box.dialog-vbox.vertical > grid.horizontal > revealer > box > box {
    // GcalTimeSelector buttons
    > button.popup.toggle {
      // prevent truncated drop-shadows
      margin: $shadow_margin_3;
    }
  }
}

@if $maj_ver == 3 {
  @if $mnr_ver > 23 {
    // for weird GtkButton with mis-halign-ed search icon
    stack.suggestionbutton > button > image {
      &:dir(ltr) {
        padding-left: calc(#{rem($widget_size)} / 2 - 0.5px
                      - (#{$icon_size} / 2));
      }
      &:dir(rtl) {
        padding-right: calc(#{rem($widget_size)} / 2 - 0.5px
                       - (#{$icon_size} / 2));
      }
    }
  }
}
@else {
  stack.suggestionbutton > button > image {
    &:dir(ltr) {
      padding-left: calc(#{rem($widget_size)} / 2 - 0.5px
                    - (#{$icon_size} / 2));
    }
    &:dir(rtl) {
      padding-right: calc(#{rem($widget_size)} / 2 - 0.5px
                     - (#{$icon_size} / 2));
    }
  }
}

// /*****************
//  * Gnome-Recipes *
//  *****************/

window.background > box.vertical > overlay > revealer.top + stack {
  margin-top: -1px; // hide weird frame
  background-color: $bg;
}

window.background > box.vertical > overlay > stack > box.vertical {
  > scrolledwindow > viewport.frame {
    box.vertical > label.heading { color: $ter_fg; }
  }
}

window.background > box.vertical > overlay > stack > box.horizontal {
  > stack > box.horizontal > scrolledwindow > viewport.frame {
    // right-pane scrolled-window
    > box.vertical {
      > label.heading { color: $ter_fg; }
    }

    // left-pane sidebar
    > list {
      @extend %sidebar_template;
      &:dir(ltr) { border-right: 1px solid $div_fg; }
      &:dir(rtl) { border-left: 1px solid $div_fg; }

      > row.activatable {
        margin: -1px 0; // kill stock CSS's border settings
        padding: 0;
        color: $sec_fg;

        &, &:focus { outline-width: 0; } // unset focus outlines

        > label.sidebar {
          color: $sec_fg;
          font-weight: 500;
          // FIXME: outset 1px solid shadows for covering ugly hard-coded
          // separators
          box-shadow: 0 -1px $bg;
        }

        &:hover {
          &, > label.sidebar { color: $fg; }
        }
        &:active,
        &:selected {
          &, &:hover {
            background-color: $trk_bg;

            &, > label.sidebar { color: $sel_label; }
          }
        }
      }
    }
  }
}

// tiles view buttons
button.tile.view { // damned stock CSS
  flowbox > flowboxchild > & {
    &:hover { box-shadow: inset 0 0 0 9999px track($fg, $a_trk_1); }
    &:active { box-shadow: inset 0 0 0 9999px track($fg, $a_trk_2); }
  }

  box > grid > & {
    &:hover {
      box-shadow: inset 0 0 0 9999px if($variant != dark,
                                        track($inv_fg, $a_trk_1),
                                        track($fg, $a_trk_1));
    }
    &:active {
      box-shadow: inset 0 0 0 9999px if($variant != dark,
                                        track($inv_fg, $a_trk_2),
                                        track($fg, $a_trk_2));
    }
  }

  &.recipe {
    &:hover,
    &:active { box-shadow: none; }

    overlay.recipe > image {
      opacity: if($variant != dark, 1.0, $a_osd);
      transition-property: opacity,
                           box-shadow;
      transition-timing-function: $tr_t_dec;
      transition-duration: $tr_d_lng;
    }

    &:hover,
    &:active {
      overlay.recipe > image { opacity: if($variant != dark, $a_osd, 1.0); }
    }
  }
}

// Note box
box.note > label { font-weight: 700; } // title

label.content.note { color: $fix_fg; } // enforce dark label color

// title and author box
overlay.recipe > image + box {
  margin-bottom: 6px; // make room from bottom edge of images
  opacity: $a_osd;
  &:dir(ltr) {
    margin-right: 12px;

    box,
    label { // labels also have solid background
      &.name.recipe { border-top-right-radius: $r_4; }
    }

    label.author.recipe { border-bottom-right-radius: $r_4; }
  }
  &:dir(rtl) {
    margin-left: 12px;

    box,
    label {
      &.name.recipe { border-top-left-radius: $r_4; }
    }

    label.author.recipe { border-bottom-left-radius: $r_4; }
  }
}

// /***************
//  * Gnome-Usage *
//  ***************/

// FIXME: why was 'adwaita.css' used for all user-themes? :/
widget {
  &#PROCESSOR,
  &#MEMORY {
    list {
      row {
        margin: -1px; // kill ugly parent borders
        border: 1px solid $div_sld_fg;

        &.max {
          color: $fix_fg; // enforce dark foreground
          // FIXME: we can't override the salmon-pinky background
          // background-image: image($destructive_color);
          // border: 1px solid $destructive_color;
        }
      }

      // kill ugly separators
      separator.list {
        box-shadow: inset 0 0 0 1px $div_sld_fg;
      }
    }
  }

  &#STORAGE {
    list {
      @extend %sidebar_template;
      margin: -1px; // kill ugly borders

      row.activatable {
        color: $sec_fg;
        &:hover,
        &:active { color: $fg; }
      }

      row:not(.activatable) { // top-most header row
        color: $ter_fg;
        box-shadow: inset 0 -1px $div_sld_fg;
      }

      // mask other ugly separators
      separator.list { box-shadow: inset 0 0 0 1px $bg; }
    }
  }
}

%graph_switcher {
  background-image: none;
  color: $sec_fg;
  font-weight: 500;
  &:hover { // use opaque
    background-image: image(mix($bg, $fg, percentage($a_fg_2nd)));
    color: $fg;
  }
  &:active,
  &:checked { // use opaque
    background-image: image( // use outline-track alpha
                        mix($sel_bg, $bg, percentage($a_trk_out)));
    color: $sel_label;
    animation: none;
  }
}

@if $maj_ver == 3 {
  @if $mnr_ver < 23 {
    graph-switcher-button.toggle { @extend %graph_switcher; }
  }
  @else {
    button.flat.graph-switcher { // >= 3.30
      @extend %graph_switcher;
    }
  }
}
@else {
  button.flat.graph-switcher { @extend %graph_switcher; }
}

box.speedometer {
  // circular progress should be drawn with our $acc_bg
  // (progress bit still looks a bit brighter than we expected though)
  &-outter { background-image: image($acc_bg); }

  &-inner { box-shadow: inset 0 0 0 5px track($acc_bg, $a_trk_out); }

  &-content-area label { color: $acc_fg; }
}

// /*********
//  * Glade *
//  *********/

GladeWindow {
  headerbar#headerbar.titlebar {
    button#recent-button.popup.toggle { // down-arrow button
      min-width: $icon_size;
      @include radius($r_2);
    }
  }

  box.horizontal scrolledwindow.frame + button.image-button {
    @include radius($r_2);
  }
}

// /********
//  * GHex *
//  ********/

menubar#MainMenu + box.vertical > widget, // main window
menubar#MainMenu + widget { // 'Add view' window(s)
  > widget {
    &:not(.view) { // left-most pane
      color: $ter_fg;
    }
  }
}

// /***************
//  * Gnome Boxes *
//  ***************/

%child_styling {
  border-radius: 0;
  &:hover { box-shadow: inset 0 0 0 9999px $trk_bg; }
  &:first-child { @include radius($r_2 $r_2 0 0, none); }
  &:last-child { @include radius(0 0 $r_2 $r_2, none); }
  &:not(:first-child):not(:only-child) { margin-top: -1px; }
}

window.background > overlay > stack.content-bg {
  &,
  stack box.content-bg { background-image: image($bg); }
}

// parent container of button nodes
box.boxes-menu.vertical > box.vertical { background-color: $base; }

// child elements
row.boxes-menu-row { @extend %child_styling; }

button.boxes-menu-row {
  @extend %child_styling;
  font-weight: 700;
  &:not(:disabled):not(:hover) { box-shadow: none; }

  box.boxes-menu.vertical > & {
    margin-bottom: -1px;
    @include radius($r_2 $r_2 0 0, none);
  }
}

// /************
//  * Shotwell *
//  ************/

// FIXME: treeview node styling is locked, there's no way to override
window.background > box.vertical > paned.horizontal {
  > paned.vertical > box.vertical + separator {
    @if $variant == dark { background-color: $div_sld_fg; }

    + frame {
      background-color: $dark_bg;

      > border { border: unset; } // unset unneeded frame
    }
  }

  // inline-toolbar?
  > box.vertical > revealer > toolbar.bottom-toolbar {
    border-top: 1px solid $div_fg;
    background-color: $dark_bg;
    &:dir(ltr) { padding-right: $toolbar_padding * 2; }
    &:dir(rtl) { padding-left: $toolbar_padding * 2; }
  }
}

// /****************
//  * Eye of Gnome *
//  ****************/

box#eog-thumb-nav { // image gallery
  iconview.view {
    @include radius(0, none);
    &:selected {
      background-color: $trk_bg;
      color: $sel_label;
      box-shadow: inset 0 4px $sel_bg;
    }
  }
}

// /*************
//  * Evolution *
//  *************/

window.background > box.vertical > box.horizontal + paned.horizontal > widget {
  > toolbutton > button.image-button.toggle {
    // damned 24px icons are not allocated at center of the parent button node
    // without meaningless padding... 
    min-width: $icon_size * 1.5;
    min-height: $icon_size * 1.5;
    padding: if($ref_weight < 1.0, $icon_size / 4, $icon_size / 2);
  }
}

infobar > revealer > box.horizontal > box + buttonbox {
  > button.flat.image-button { @include radius($r_2); }

  > button + box.linked > button {
    &:not(.destructive-action):not(.suggested-action) {
      &.text-button,
      &.toggle {
        min-width: 0; // FIXME: force loading 16px arrow images
        padding: 0 rem($txt_button_lr_space / 2);
      }
    }
  }
}

// /****************
//  * Gnome Clocks *
//  ****************/

%hdyviewswitcher {
  button.radio {
    @include radius(0);
    border: none;
    background-image: none; // kill ink-reactions
    &:active,
    &:checked {
      background-image: none;
      &:hover { @include button(checked-hover); }
    }

    // override  app's padding values
    box.horizontal.wide { margin: -8px 0; }

    box.vertical.narrow {
      // override  app's padding values
      margin: -5px 0 -7px;

      label {
        margin: if($ref_weight < 1.0, -2px 0 0,
                                      -1px 0 0);
      }

      image {
        margin: if($ref_weight < 1.0, (-5px + 2px) 0 -2px,
                                      0 0 -1px);
      }
    }

    label {
      &,
      &:active { font-weight: 500; }
    }
  }
}

@if $maj_ver == 3 {
  @if $mnr_ver > 23 {
    headerbar hdyviewswitcher { @extend %hdyviewswitcher; }
  }
}
@else {
  headerbar hdyviewswitcher { @extend %hdyviewswitcher; }
}
